create or replace TRIGGER LOG_CDP_RECURETAPAOP
AFTER DELETE OR INSERT OR UPDATE
ON RECURETAPAOP FOR EACH ROW
DECLARE
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
  V_DESC         VARCHAR2(2000);
  V_ITPESQ       VARCHAR2(80);
  V_NMOPERADOR   VARCHAR2(40);
  V_IDTIPOOPER   VARCHAR2(1);
  V_CDFILLOGOPER VARCHAR2(4);
  V_TAM          INTEGER;

BEGIN
/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/

   V_DESC       := '';
   V_ITPESQ     := '';
   V_NMOPERADOR := '';
   V_IDTIPOOPER := '';
   V_CDFILLOGOPER := '';
   
   NMUSUARIO(V_NMOPERADOR);
   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);

   IF INSERTING THEN

      IF :NEW.CDFILIAL IS NOT NULL THEN
         V_DESC := V_DESC || 'CDFILIAL= ' || NVL(:NEW.CDFILIAL,'') || ' ' ;
      END IF;

      IF :NEW.NRAUDITORIA IS NOT NULL THEN
         V_DESC := V_DESC || 'NRAUDITORIA= ' || NVL(:NEW.NRAUDITORIA,'') || ' ' ;
      END IF;

      IF :NEW.NRINSPECAUDI IS NOT NULL THEN
         V_DESC := V_DESC || 'NRINSPECAUDI= ' || NVL(:NEW.NRINSPECAUDI,'') || ' ' ;
      END IF;

      IF :NEW.NRRECUETAPOP IS NOT NULL THEN
         V_DESC := V_DESC || 'NRRECUETAPOP= ' || NVL(:NEW.NRRECUETAPOP,'') || ' ' ;
      END IF;

      IF :NEW.CDEQUIPPRO IS NOT NULL THEN
         V_DESC := V_DESC || 'CDEQUIPPRO= ' || NVL(:NEW.CDEQUIPPRO,'') || ' ' ;
      END IF;

      IF :NEW.CDHABILIDADE IS NOT NULL THEN
         V_DESC := V_DESC || 'CDHABILIDADE= ' || NVL(:NEW.CDHABILIDADE,'') || ' ' ;
      END IF;

      IF :NEW.CDOPERADOR IS NOT NULL THEN
         V_DESC := V_DESC || 'CDOPERADOR= ' || NVL(:NEW.CDOPERADOR,'') || ' ' ;
      END IF;

      IF :NEW.DTINIUTRECOP IS NOT NULL THEN
         V_DESC := V_DESC || 'DTINIUTRECOP= ' || NVL(:NEW.DTINIUTRECOP,'') || ' ' ;
      END IF;

      IF :NEW.DTFINUTRECOP IS NOT NULL THEN
         V_DESC := V_DESC || 'DTFINUTRECOP= ' || NVL(:NEW.DTFINUTRECOP,'') || ' ' ;
      END IF;

      IF :NEW.QTPRODRECUOP IS NOT NULL THEN
         V_DESC := V_DESC || 'QTPRODRECUOP= ' || NVL(:NEW.QTPRODRECUOP,'') || ' ' ;
      END IF;

      IF :NEW.QTHRPRERECOP IS NOT NULL THEN
         V_DESC := V_DESC || 'QTHRPRERECOP= ' || NVL(:NEW.QTHRPRERECOP,'') || ' ' ;
      END IF;

      IF :NEW.IDRECURETAOP IS NOT NULL THEN
         V_DESC := V_DESC || 'IDRECURETAOP= ' || NVL(:NEW.IDRECURETAOP,'') || ' ' ;
      END IF;

      IF :NEW.NRORDUTRECOP IS NOT NULL THEN
         V_DESC := V_DESC || 'NRORDUTRECOP= ' || NVL(:NEW.NRORDUTRECOP,'') || ' ' ;
      END IF;

      IF :NEW.QTHRREARECOP IS NOT NULL THEN
         V_DESC := V_DESC || 'QTHRREARECOP= ' || NVL(:NEW.QTHRREARECOP,'') || ' ' ;
      END IF;

      IF :NEW.CDINSPECAO IS NOT NULL THEN
         V_DESC := V_DESC || 'CDINSPECAO= ' || NVL(:NEW.CDINSPECAO,'') || ' ' ;
      END IF;

      IF :NEW.CDSETOR IS NOT NULL THEN
         V_DESC := V_DESC || 'CDSETOR= ' || NVL(:NEW.CDSETOR,'') || ' ' ;
      END IF;

      IF :NEW.IDLIBERECUOP IS NOT NULL THEN
         V_DESC := V_DESC || 'IDLIBERECUOP= ' || NVL(:NEW.IDLIBERECUOP,'') || ' ' ;
      END IF;

      IF :NEW.CDGRUPOEQUIPA IS NOT NULL THEN
         V_DESC := V_DESC || 'CDGRUPOEQUIPA= ' || NVL(:NEW.CDGRUPOEQUIPA,'') || ' ' ;
      END IF;

      IF :NEW.IDSITPTCRIT IS NOT NULL THEN
         V_DESC := V_DESC || 'IDSITPTCRIT= ' || NVL(:NEW.IDSITPTCRIT,'') || ' ' ;
      END IF;

      IF :NEW.QTOPERADORES IS NOT NULL THEN
         V_DESC := V_DESC || 'QTOPERADORES= ' || NVL(:NEW.QTOPERADORES,'') || ' ' ;
      END IF;

      IF :NEW.QTPRODTAR IS NOT NULL THEN
         V_DESC := V_DESC || 'QTPRODTAR= ' || NVL(:NEW.QTPRODTAR,'') || ' ' ;
      END IF;

      IF :NEW.NRRECURPAI IS NOT NULL THEN
         V_DESC := V_DESC || 'NRRECURPAI= ' || NVL(:NEW.NRRECURPAI,'') || ' ' ;
      END IF;

      IF :NEW.IDSITGRAVCONT IS NOT NULL THEN
         V_DESC := V_DESC || 'IDSITGRAVCONT= ' || NVL(:NEW.IDSITGRAVCONT,'') || ' ' ;
      END IF;

      V_ITPESQ := :NEW.CDFILIAL || :NEW.NRAUDITORIA || :NEW.NRINSPECAUDI || :NEW.NRRECUETAPOP;

      V_IDTIPOOPER := '1';

   END IF;

   IF UPDATING THEN

      IF (:NEW.CDFILIAL <> :OLD.CDFILIAL) THEN
         V_DESC := V_DESC || 'CDFILIAL= ' || NVL(:NEW.CDFILIAL,'') || ' ' ;
      END IF;

      IF (:NEW.NRAUDITORIA <> :OLD.NRAUDITORIA) THEN
         V_DESC := V_DESC || 'NRAUDITORIA= ' || NVL(:NEW.NRAUDITORIA,'') || ' ' ;
      END IF;

      IF (:NEW.NRINSPECAUDI <> :OLD.NRINSPECAUDI) THEN
         V_DESC := V_DESC || 'NRINSPECAUDI= ' || NVL(:NEW.NRINSPECAUDI,'') || ' ' ;
      END IF;

      IF (:NEW.NRRECUETAPOP <> :OLD.NRRECUETAPOP) THEN
         V_DESC := V_DESC || 'NRRECUETAPOP= ' || NVL(:NEW.NRRECUETAPOP,'') || ' ' ;
      END IF;

      IF (:NEW.CDEQUIPPRO <> :OLD.CDEQUIPPRO) THEN
         V_DESC := V_DESC || 'CDEQUIPPRO= ' || NVL(:NEW.CDEQUIPPRO,'') || ' ' ;
      END IF;

      IF (:NEW.CDHABILIDADE <> :OLD.CDHABILIDADE) THEN
         V_DESC := V_DESC || 'CDHABILIDADE= ' || NVL(:NEW.CDHABILIDADE,'') || ' ' ;
      END IF;

      IF (:NEW.CDOPERADOR <> :OLD.CDOPERADOR) THEN
         V_DESC := V_DESC || 'CDOPERADOR= ' || NVL(:NEW.CDOPERADOR,'') || ' ' ;
      END IF;

      IF (:NEW.DTINIUTRECOP <> :OLD.DTINIUTRECOP) THEN
         V_DESC := V_DESC || 'DTINIUTRECOP= ' || NVL(:NEW.DTINIUTRECOP,'') || ' ' ;
      END IF;

      IF (:NEW.DTFINUTRECOP <> :OLD.DTFINUTRECOP) THEN
         V_DESC := V_DESC || 'DTFINUTRECOP= ' || NVL(:NEW.DTFINUTRECOP,'') || ' ' ;
      END IF;

      IF (:NEW.QTPRODRECUOP <> :OLD.QTPRODRECUOP) THEN
         V_DESC := V_DESC || 'QTPRODRECUOP= ' || NVL(:NEW.QTPRODRECUOP,'') || ' ' ;
      END IF;

      IF (:NEW.QTHRPRERECOP <> :OLD.QTHRPRERECOP) THEN
         V_DESC := V_DESC || 'QTHRPRERECOP= ' || NVL(:NEW.QTHRPRERECOP,'') || ' ' ;
      END IF;

      IF (:NEW.IDRECURETAOP <> :OLD.IDRECURETAOP) THEN
         V_DESC := V_DESC || 'IDRECURETAOP= ' || NVL(:NEW.IDRECURETAOP,'') || ' ' ;
      END IF;

      IF (:NEW.NRORDUTRECOP <> :OLD.NRORDUTRECOP) THEN
         V_DESC := V_DESC || 'NRORDUTRECOP= ' || NVL(:NEW.NRORDUTRECOP,'') || ' ' ;
      END IF;

      IF (:NEW.QTHRREARECOP <> :OLD.QTHRREARECOP) THEN
         V_DESC := V_DESC || 'QTHRREARECOP= ' || NVL(:NEW.QTHRREARECOP,'') || ' ' ;
      END IF;

      IF (:NEW.CDINSPECAO <> :OLD.CDINSPECAO) THEN
         V_DESC := V_DESC || 'CDINSPECAO= ' || NVL(:NEW.CDINSPECAO,'') || ' ' ;
      END IF;

      IF (:NEW.CDSETOR <> :OLD.CDSETOR) THEN
         V_DESC := V_DESC || 'CDSETOR= ' || NVL(:NEW.CDSETOR,'') || ' ' ;
      END IF;

      IF (:NEW.IDLIBERECUOP <> :OLD.IDLIBERECUOP) THEN
         V_DESC := V_DESC || 'IDLIBERECUOP= ' || NVL(:NEW.IDLIBERECUOP,'') || ' ' ;
      END IF;

      IF (:NEW.CDGRUPOEQUIPA <> :OLD.CDGRUPOEQUIPA) THEN
         V_DESC := V_DESC || 'CDGRUPOEQUIPA= ' || NVL(:NEW.CDGRUPOEQUIPA,'') || ' ' ;
      END IF;

      IF (:NEW.IDSITPTCRIT <> :OLD.IDSITPTCRIT) THEN
         V_DESC := V_DESC || 'IDSITPTCRIT= ' || NVL(:NEW.IDSITPTCRIT,'') || ' ' ;
      END IF;

      IF (:NEW.QTOPERADORES <> :OLD.QTOPERADORES) THEN
         V_DESC := V_DESC || 'QTOPERADORES= ' || NVL(:NEW.QTOPERADORES,'') || ' ' ;
      END IF;

      IF (:NEW.QTPRODTAR <> :OLD.QTPRODTAR) THEN
         V_DESC := V_DESC || 'QTPRODTAR= ' || NVL(:NEW.QTPRODTAR,'') || ' ' ;
      END IF;

      IF (:NEW.NRRECURPAI <> :OLD.NRRECURPAI) THEN
         V_DESC := V_DESC || 'NRRECURPAI= ' || NVL(:NEW.NRRECURPAI,'') || ' ' ;
      END IF;

      IF (:NEW.IDSITGRAVCONT <> :OLD.IDSITGRAVCONT) THEN
         V_DESC := V_DESC || 'IDSITGRAVCONT= ' || NVL(:NEW.IDSITGRAVCONT,'') || ' ' ;
      END IF;

      V_ITPESQ := :NEW.CDFILIAL || :NEW.NRAUDITORIA || :NEW.NRINSPECAUDI || :NEW.NRRECUETAPOP;

      V_IDTIPOOPER := '2';

   END IF;

   IF DELETING  THEN

      IF :OLD.CDFILIAL IS NOT NULL THEN
         V_DESC := V_DESC || 'CDFILIAL= ' || NVL(:OLD.CDFILIAL,'') || ' ' ;
      END IF;

      IF :OLD.NRAUDITORIA IS NOT NULL THEN
         V_DESC := V_DESC || 'NRAUDITORIA= ' || NVL(:OLD.NRAUDITORIA,'') || ' ' ;
      END IF;

      IF :OLD.NRINSPECAUDI IS NOT NULL THEN
         V_DESC := V_DESC || 'NRINSPECAUDI= ' || NVL(:OLD.NRINSPECAUDI,'') || ' ' ;
      END IF;

      IF :OLD.NRRECUETAPOP IS NOT NULL THEN
         V_DESC := V_DESC || 'NRRECUETAPOP= ' || NVL(:OLD.NRRECUETAPOP,'') || ' ' ;
      END IF;

      IF :OLD.CDEQUIPPRO IS NOT NULL THEN
         V_DESC := V_DESC || 'CDEQUIPPRO= ' || NVL(:OLD.CDEQUIPPRO,'') || ' ' ;
      END IF;

      IF :OLD.CDHABILIDADE IS NOT NULL THEN
         V_DESC := V_DESC || 'CDHABILIDADE= ' || NVL(:OLD.CDHABILIDADE,'') || ' ' ;
      END IF;

      IF :OLD.CDOPERADOR IS NOT NULL THEN
         V_DESC := V_DESC || 'CDOPERADOR= ' || NVL(:OLD.CDOPERADOR,'') || ' ' ;
      END IF;

      IF :OLD.DTINIUTRECOP IS NOT NULL THEN
         V_DESC := V_DESC || 'DTINIUTRECOP= ' || NVL(:OLD.DTINIUTRECOP,'') || ' ' ;
      END IF;

      IF :OLD.DTFINUTRECOP IS NOT NULL THEN
         V_DESC := V_DESC || 'DTFINUTRECOP= ' || NVL(:OLD.DTFINUTRECOP,'') || ' ' ;
      END IF;

      IF :OLD.QTPRODRECUOP IS NOT NULL THEN
         V_DESC := V_DESC || 'QTPRODRECUOP= ' || NVL(:OLD.QTPRODRECUOP,'') || ' ' ;
      END IF;

      IF :OLD.QTHRPRERECOP IS NOT NULL THEN
         V_DESC := V_DESC || 'QTHRPRERECOP= ' || NVL(:OLD.QTHRPRERECOP,'') || ' ' ;
      END IF;

      IF :OLD.IDRECURETAOP IS NOT NULL THEN
         V_DESC := V_DESC || 'IDRECURETAOP= ' || NVL(:OLD.IDRECURETAOP,'') || ' ' ;
      END IF;

      IF :OLD.NRORDUTRECOP IS NOT NULL THEN
         V_DESC := V_DESC || 'NRORDUTRECOP= ' || NVL(:OLD.NRORDUTRECOP,'') || ' ' ;
      END IF;

      IF :OLD.QTHRREARECOP IS NOT NULL THEN
         V_DESC := V_DESC || 'QTHRREARECOP= ' || NVL(:OLD.QTHRREARECOP,'') || ' ' ;
      END IF;

      IF :OLD.CDINSPECAO IS NOT NULL THEN
         V_DESC := V_DESC || 'CDINSPECAO= ' || NVL(:OLD.CDINSPECAO,'') || ' ' ;
      END IF;

      IF :OLD.CDSETOR IS NOT NULL THEN
         V_DESC := V_DESC || 'CDSETOR= ' || NVL(:OLD.CDSETOR,'') || ' ' ;
      END IF;

      IF :OLD.IDLIBERECUOP IS NOT NULL THEN
         V_DESC := V_DESC || 'IDLIBERECUOP= ' || NVL(:OLD.IDLIBERECUOP,'') || ' ' ;
      END IF;

      IF :OLD.CDGRUPOEQUIPA IS NOT NULL THEN
         V_DESC := V_DESC || 'CDGRUPOEQUIPA= ' || NVL(:OLD.CDGRUPOEQUIPA,'') || ' ' ;
      END IF;

      IF :OLD.IDSITPTCRIT IS NOT NULL THEN
         V_DESC := V_DESC || 'IDSITPTCRIT= ' || NVL(:OLD.IDSITPTCRIT,'') || ' ' ;
      END IF;

      IF :OLD.QTOPERADORES IS NOT NULL THEN
         V_DESC := V_DESC || 'QTOPERADORES= ' || NVL(:OLD.QTOPERADORES,'') || ' ' ;
      END IF;

      IF :OLD.QTPRODTAR IS NOT NULL THEN
         V_DESC := V_DESC || 'QTPRODTAR= ' || NVL(:OLD.QTPRODTAR,'') || ' ' ;
      END IF;

      IF :OLD.NRRECURPAI IS NOT NULL THEN
         V_DESC := V_DESC || 'NRRECURPAI= ' || NVL(:OLD.NRRECURPAI,'') || ' ' ;
      END IF;

      IF :OLD.IDSITGRAVCONT IS NOT NULL THEN
         V_DESC := V_DESC || 'IDSITGRAVCONT= ' || NVL(:OLD.IDSITGRAVCONT,'') || ' ' ;
      END IF;
             
      V_ITPESQ := :OLD.CDFILIAL || :OLD.NRAUDITORIA || :OLD.NRINSPECAUDI || :OLD.NRRECUETAPOP;

      V_IDTIPOOPER := '3';

   END IF;

   IF NOT (V_DESC IS NULL) THEN
      V_TAM := LENGTH(V_DESC);
      WHILE (V_TAM >= 0) LOOP
         INSERT INTO LOGOPERA ( NMTABELA, DTOPERACAO, NMRESPOPER,
                                IDTIPOOPER,   DSOPERACAO, CDPESQITEM,
                                DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER,
                                DSMETUSUOPER, CDORESPOPER, CDFILLOGOPER)
                      VALUES  ('RECURETAPAOP', SYSDATE ,    NVL(V_NMOPERADOR,' '),
                                V_IDTIPOOPER,  SUBSTR(V_DESC,1,300), V_ITPESQ,
                                V_DSSERVERRDM, V_DSREMOTEADDR,  V_DSREMOTEHOST,
                                V_DSSERVMETHOD,   V_DSREMOTEOPER, V_CDFILLOGOPER);
         V_DESC := SUBSTR(V_DESC, 300, V_TAM);
         V_TAM := LENGTH(V_DESC);
      END LOOP;

   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_CDP_RECURETAPAOP','6.05.xxx'); END;
/